2016暑期集训4-I
HDU 1542 Atlantis
扫描线 矩形面积并
传送门:HDU
传送门:HustOJ
题意
给几个矩形(左下点和右上点),求面积并。
思路
线段树,矩形面积并。基本思路百度吧。说说细节。
- 用一个结构体存横边。
struct EDGE
{
//横边的结构体
double l,r,h;//左端点,右端点,纵坐标
int k;//下侧边是1,上侧边为1
bool operator < (const EDGE& a)//重载< 排序用
{
return h<a.h;
}
};
线段树里面保存内容:保存被占用的区间长度。因为线段树区间是整数,所以离散化,即将横坐标与pos数组下标对应,排序,每次取出一条线段,取出线段的lr值,在pos数组里面二分查找,找到pos数组下标并更新。每次pushup时取pos[]的差,即覆盖的长度。
每次取出一条线段更新后,计算一下当前块的面积。
代码
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <vector>
#include <queue>
#include <stack>
#include <iomanip>
#include <string>
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
using namespace std;
const int MAXN=100007;
const int MA_XN=207;
const int oo=2000000007;
const long long int loo=2000000000000000007ll;
typedef long long int ll;
typedef struct {
int cnt;
double lenth;
} tree;
tree sum[MAXN<<2];//线段树
struct EDGE {//横边的结构体
double l,r,h;
int k;
bool operator < (const EDGE& a)//重载< 排序用
{
return h<a.h;
}
};
typedef struct EDGE Edge;
Edge e[MAXN<<1];//横边数组
double pos[MAXN<<1];
void PushUP(int rt,int l,int r) {
if(sum[rt].cnt)
{
sum[rt].lenth=pos[r+1]-pos[l];
}
else if(l==r)
{
sum[rt].lenth=0;
}
else
{
sum[rt].lenth=sum[rt<<1].lenth+sum[rt<<1|1].lenth;
}
}
void update(int L,int R,int c,int l,int r,int rt)
{
if(L<=l&&r<=R)
{
sum[rt].cnt+=c;
PushUP(rt,l,r);
return;
}
int m=(l+r)>>1;
if(L<=m)
{
update(L,R,c,lson);
}
if(R>m)
{
update(L,R,c,rson);
}
PushUP(rt,l,r);
}
int main()
{
int n,ca=1;
while((~scanf("%d",&n))&&(n))
{
memset(sum,0,sizeof(sum));
memset(e,0,sizeof(e));
memset(pos,0,sizeof(pos));
int number=0;
for(int i=0; i < n; i++,number+=2)
{
double x1,x2,y1,y2;
scanf("%lf%lf%lf%lf",&x1,&y1,&x2,&y2);
e[number].l=x1; e[number].r=x2; e[number].h=y1; e[number].k=1;
e[number+1].l=x1; e[number+1].r=x2; e[number+1].h=y2; e[number+1].k=-1;
pos[number]=x1; pos[number+1]=x2;
}
sort(e,e+number);
sort(pos,pos+number);
int m=1;
for(int i=1; i<number; i++)//去重
{
if(pos[i]!=pos[i-1])
{
pos[m++]=pos[i];
}
}
double res=0;
for(int i=0; i<number; i++)
{
int l=lower_bound(pos,pos+m,e[i].l)-pos;
int r=lower_bound(pos,pos+m,e[i].r)-pos-1;
if(l<=r) update(l,r,e[i].k,0,m-1,1);
res+=(e[i+1].h-e[i].h)*sum[1].lenth;
}
printf("Test case #%d\nTotal explored area: %.2lf\n\n",ca++,res);
}
return 0;
}